/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsaddcolumn
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Add a column to a table
	Description: Add a column to a table


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <dal_utilities.h>


#include "dsaddcolumn.h"

void dsaddcolumn()
{
	PROC
	const string		tableName( stringParameter( "table" ));
	const string		name( stringParameter( "name" ));
	const string		type( stringParameter( "type" ));
	//const bool		withSize( booleanParameter( "withsize" ) );
	const vector<int>	s( intListParameter( "size" ) );
	longVec			size;
	for( unsigned int i = 0; i < s.size(); ++i ) size.push_back( s[ i ] );
	//const bool		withUnits( booleanParameter( "withunits" ) );
	const string		units( stringParameter( "units" ));
	//const bool		withLabel( booleanParameter( "withlabel" ) );
	const string		label( stringParameter( "label" ));
	const bool		withNull( booleanParameter( "withnull" ) );
	const int		nullValue( intParameter( "null" ) );
	//const bool		withData( booleanParameter( "data" ) );
	//const string		data( stringParameter( "data" ));
	const bool		withPosition( booleanParameter( "withposition" ) );
	int			position( intParameter( "position" ));

	DataSet*		dataset( dataSetServer -> open( tableName, DataSet::Modify ) );
	Table*			table( dataset -> table( tableName ) );
	Column*			column;

	if( withPosition )
	{
		column = table -> addColumn( name, toDalDataType( type ), label, units, size, position );
	}
	else
	{
		column = table -> addColumn( name, toDalDataType( type ), label, units, size );
	}// if

	if( withNull )
	{
		column -> nullValue( nullValue );
	} // if
	dataSetServer -> close( dataset );
	ENDPROC
}
