/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dscopyattr
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Copy a list of attributes to an attributable
	Description: Copy a list of attributes to an attributable


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>


#include "dscopyattr.h"

void dscopyattr()
{
	PROC
	const vector<string>	attributes( stringListParameter( "attributes" ) );
	string			to( stringParameter( "to" ) );
	DataSet*		dsnSet( dataSetServer -> open( to, Dal::Modify, DataSetServer::Low ) );
	CompoundName		dcn( to, CompoundName::AnyAttributableName, dsnSet );
	Attributable*		dsnAttributable = dcn.attributable();

	for( unsigned int i = 0; i < attributes.size(); ++i )
	{
		const string		name( attributes[ i ] );
		DataSet*		srcSet( dataSetServer -> open( name, Dal::Read, DataSetServer::Low ) );
		const CompoundName	scn( name, CompoundName::AnyAttributeName, srcSet );
		const Attributable*	srcAttributable = scn.attributable();
		const Attribute*	attribute( srcAttributable -> attribute( name ) );

		dsnAttributable -> addAttribute( attribute );
		dataSetServer -> close( srcSet );
	} // for
	dataSetServer -> close( dsnSet );
	ENDPROC
}
