/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dscopycolumn
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Copy a list of columns to a table
	Description: Copy a list of columns to a table


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>


#include "dscopycolumn.h"

void dscopycolumn()
{
	PROC
	const vector<string>	columns( stringListParameter( "columns" ) );
	string			to( stringParameter( "to" ) );
	DataSet*		dsnSet( dataSetServer -> open( to, Dal::Modify ) );
	Table*			dsnTable( dsnSet -> table( to ) );

	for( unsigned int i = 0; i < columns.size(); ++i )
	{
		const string		name( columns[ i ] );
		DataSet*		srcSet( dataSetServer -> open( name, Dal::Read ) );
		Table*			srcTable( srcSet -> table( name ) );
		Column*			srcColumn( srcTable -> column( name ) );

		dsnTable -> add( srcColumn );
		dataSetServer -> close( srcSet );

	} // for

	dataSetServer -> close( dsnSet );

	ENDPROC
}
