/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsrelabel
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Relabel an object
	Description: Relabel an object


*/

#include <Tracer.h>
#include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>



#include "dsrelabel.h"

void dsrelabel()
{
	PROC

	const string		name( stringParameter( "object" ) );
	const string		newLabel( stringParameter( "newlabel" ) );

	DataSet*		set( dataSetServer -> open( name, Dal::Modify, DataSetServer::Low ) );
	const CompoundName	cn( name, CompoundName::Any, set );

	switch( cn.state() )
	{
		//case CompoundName::DataSetName :
		//	set -> rename( newName);
		//	break;
		case CompoundName::BlockName :
		case CompoundName::TableName :
		case CompoundName::ArrayName :
			set -> block( name ) -> relabel( newLabel );
			break;
		case CompoundName::ColumnName :
			set -> table( name ) -> column( name ) -> relabel( newLabel );
			break;
		case CompoundName::DataSetAttributeName :
		case CompoundName::BlockAttributeName :
		case CompoundName::ColumnAttributeName :
			cn.attributable() -> attribute( name ) -> relabel( newLabel );
			break;
		default :
			errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );
	} // switch

	dataSetServer -> close( set );

	ENDPROC
}
