/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsrmattr
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Delete a list of attributes from an attributable
	Description: Delete a list of attributes from an attributable


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>


#include "dsrmattr.h"

void dsrmattr()
{
	PROC
	const vector<string>	attributes( stringListParameter( "attributes" ) );

	for( unsigned int i = 0; i < attributes.size(); ++i )
	{
		const string		name( attributes[ i ] );
		DataSet*		set( dataSetServer -> open( name, Dal::Modify, DataSetServer::Low ) );
		const CompoundName	cn( name, CompoundName::AnyAttributeName, set );
		Attributable*		attributable = cn.attributable();

		attributable -> deleteAttribute( name );
		dataSetServer -> close( set );
	} // for
	ENDPROC
}
