/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsverify
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Check a dataset.
	Description: Check a dataset using the output from dstruct.


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
//#include <errstr.h>
//#include <dal_utilities.h>


#include "DataSetStruct.h"
#include "dsverify.h"

/*
static void
checkAttribute(
	const Attributable*	att,
	const AttributeStruct*	attributeStruct )
{
	PROC
	if( !att -> hasAttribute( attributeStruct -> name() ) )
	{
		errstr << "Expected attributable with qualified name " << att -> qualifiedName() << " to have an attribute with name " << attributeStruct -> name() << Sas::error( "attributeNotFound" );
	} // if

	const Attribute* checkThisAttribute = att -> attribute( attributeStruct -> name() );

	if( checkThisAttribute -> dataType() != attributeStruct -> dataType() )
	{
		errstr << "Expected attribute with qualified name " << checkThisAttribute -> qualifiedName() << " to have data type " << toString( attributeStruct -> dataType() ) << " but found " << toString( checkThisAttribute -> dataType() ) << Sas::error( "wrongDataType" );
	} // if
	ENDPROC
}


static void
checkAttributable(
	const Attributable*		att,
	const AttributableStruct*	attributableStruct )
{
	PROC
	if( att -> attributes() != attributableStruct -> attributeStructs() )
	{
		errstr << "Expected attributable with qualified name " << att -> qualifiedName() << " to have " << attributableStruct -> attributeStructs() << " attributes, but " << att -> attributes() << " were found" << Sas::error( "wrongNumberOfAttributes" );
	} // if

	for(
		unsigned int i = 0;
		i < attributableStruct -> attributeStructs();
		++i )
	{
		checkAttribute( att, attributableStruct -> attributeStruct( i ) );
	} // for
	ENDPROC
}


static void
checkTable(
	const DataSet*		ds,
	const TableStruct*	tableStruct )
{
	PROC
	const Block* bk = ds -> block( tableStruct -> name() );

	if( bk -> type() != Block::TableT )
	{
		errstr << "Expected block with name '" << tableStruct -> name() << "' to be a table" << Sas::error( "wrongBlockType" );
	} // if

	ENDPROC
}


static void
checkArray(
	const DataSet*		ds,
	const ArrayStruct*	arrayStruct )
{
	PROC

	const Block* bk = ds -> block( arrayStruct -> name() );

	if( bk -> type() != Block::ArrayT )
	{
		errstr << "Expected block with name '" << arrayStruct -> name() << "' to be an array" << Sas::error( "wrongBlockType" );
	} // if

	ENDPROC
}


static void
checkBlock(
	const DataSet*		ds,
	const BlockStruct*	blockStruct )
{
	PROC

	if( !ds -> hasBlock( blockStruct -> name() ))
	{
		errstr << "Expected a block with name " << blockStruct -> name() << Sas::error( "missingBlock" );
	} // if

	switch( blockStruct -> type() )
	{
		case Block::TableT :
			checkTable( ds, blockStruct -> parent() -> tableStruct( blockStruct -> number() ));
			break;
		case Block::ArrayT :
			checkArray( ds, blockStruct -> parent() -> arrayStruct( blockStruct -> number()) );
			break;
		default :
			errstr << Sas::error( "internalError" );
			break;
	} // switch
	ENDPROC
}


static void
checkDataSet( const DataSetStruct* dataSetStruct )
{
	PROC
	if( !dataSetServer -> exists( dataSetStruct -> name() ) )
	{
		errstr << "Expected a dataset with name " << dataSetStruct -> name() << " to exist" << Sas::error( "datasetDoesNotExist" );
	} // if

	DataSet* ds = dataSetServer -> open( dataSetStruct -> name(), Dal::Read );

	checkAttributable( ds, dataSetStruct );

	if( ds -> blocks() != dataSetStruct -> blockStructs() )
	{
		errstr << "Set " << ds -> name() << " contains " << ds -> blocks();
		errstr << " but expected " << dataSetStruct -> blockStructs();
		errstr << " blocks." << Sas::error( "wrongNumberOfBlocks" );
	} // if

	for(
		unsigned int i = 0;
		i < dataSetStruct -> blockStructs();
		++i )
	{
		checkBlock( ds, dataSetStruct -> blockStruct( i ) );
	} // for
	dataSetServer -> close( ds );

	ENDPROC
}


static void
checkDataSets()
{
	PROC
	for( unsigned int i = 0; i < dataSetStructServer -> dataSetStructs(); ++ i )
	{
		checkDataSet( dataSetStructServer -> dataSetStruct( i ) );
	} // for
	ENDPROC
}


static void
checkStdAttribute(
	const Attributable*	attributable,
	const _Attribute*	attribute,
	unsigned int		attributeNumber )
{
	PROC
	const Attribute* attribute = attributable -> attribute( attributeDescriptor._name );
	assert( attribute -> attributeNumber() == attributeNumber );
	assert( attribute -> asString() == attributeDescriptor._value.asString() );

	switch( attribute -> dataType() )
	{
		case Attribute::Int :
			assert( attributeDescriptor._type == "Int" );
			break;
		case Attribute::Real :
			assert( attributeDescriptor._type == "Real" );
			break;
		case Attribute::Bool :
			assert( attributeDescriptor._type == "Bool" );
			break;
		case Attribute::DString :
			assert( attributeDescriptor._type == "String" );
			break;
		default :
			errstr << "Invalid switch" << Sas::error( "internalError" );
			break;
	} // switch
	ENDPROC
}
*/

void dsverify()
{
	PROC
	const vector<string>	files( stringListParameter( "files" ) );
	for( unsigned int i = 0; i < files.size(); ++i )
	{
		const string		name( files[ i ] );
		dataSetStructServer -> readDataSetStructs( name, true );
		for( unsigned int j = 0; j < dataSetStructServer -> dataSetStructs(); ++j )
		{
			const DataSetStruct*	dataSetStruct = dataSetStructServer -> dataSetStruct( j );
			dataSetStruct -> check();
		} // for
		dataSetStructServer -> releaseDataSetStructs();
	} // for
	ENDPROC
}


